Subject: bug#49039: Aspell in Emacs

From: [email-masked]
Date: Tue, 15 Jun 2021 21:20:29 +0200 (CEST)

From: Eli Zaretskii <[email-masked]>
To: [email-masked]
Subject: Re: bug#49039: Aspell in Emacs
Date: 15/06/2021 20:12:22 Europe/Paris
Cc: [email-masked]

>> From: [email-masked]
>> Cc: [email-masked]
>> Date: Tue, 15 Jun 2021 20:03:53 +0200 (CEST)
>> 
>> > > It looks to me that it is basically a hack of ispell, likely the result that it was easier 
>> > > and quicker for the developer to do it that way. Correct me if I am wrong.
>> 
>> > You are wrong. Please read the code, don't just judge it by the name
>> of the package (which is just a historic incident).
>> 
>> It is valuable to go past the historic after significant time has passed as it easily leads
>> to confusion or obfuscation.
>> 
>> May I suggest that the generic framework uses a name which in different that using
>> the old ispell name. And within that framowork, one could call ispell, aspell or whatever,
>> so there is no longer a conflict of understanding between ispell the framework and ispell
>> the program.

>We are not going to change the names, sorry. Too many Emacs users are
>used to these names.

Then it would be good to have the program ispell deprecated and letting aspell

take over, following the Gnu Project Plan.

>> > > Had tried lookinf for the self documentation for ispell-program-name, but could not 
>> > > access anything.
>> 
>> > "C-h v ispell-program-name RET" would have shown its documentation.
>> 
>> There are no matches for ispell-program-name if you try to do C-h v ispell-program-name

>There will be once you invoke the first ispell-* command.

Let's try to avoid such requirement and have the ability to access that information

without having to call other ispell commands first.  There could be ispell-mode, once

a user activates it, the documentation for all ispell functionality would be available.

>> > In any case, since Emacs already looks for known spell-checkers, and
>> > already prefers aspell, my conclusion from the fact that it didn't
>> > work for you is that you have some unusual setup, which should be
>> > quite rare nowadays. The defaults are set such that the user will not
>> > need to know about this variable.
>> 
>> There has been a misunderstanding that aspell was not working. It was 
>> working but my impression was that using ispell on emacs was using
>> ispell the program.
>> 
>> I am convinced that the user should know about the variable. It is an important
>> variable and users should know what spell checker is being used.

>Then I'm sorry, but we will have to agree to disagree on that.

Or be able to get to know about it from emacs self documentation and from manual.

I frequently try to get information from emacs.  Emacs has too many hidden things.

The added benefit would be that people would know about the standalone program.

Or do people not really use spell checker in emacs much?

>> > IOW, spelling with aspell in Emacs should work as long as invoking
>> > aspell from the shell prompt works. If it doesn't work to invoke
>> > aspell from the shell prompt, then you should first correct your
>> > system's configuration so that it does.
>> 
>> Correct, but it is hard to understand what spelling program is being used.

>You can always ask. Like here: you asked and got the answer.

Yes, but do you really wanted users to always have to ask.  And do users really

want to have to ask to know.  Personally, I want to get on with my work, without

wasting time asking about this and that.  Would also avoid the frustration of people

responding to tho same question over and over again.  From operational point of

view, when a question is being asked too frequently, it is indication of some deficit.

>> Gnu packages should work well together. The Gnu Aspell manual says that 
>> Aspell is a Free and Open Source spell checker designed to eventually replace
>> Ispell.This creates confusion and emacs should stop using ispell by name,
>> except when it is actually using the ispell checker.

>You are again sticking to the name. The name is not important: I'm

>quite sure Emacs was using aspell on your system (if it is installed),

Good. I wanted to use aspell.  Am not sticking with the name, but it is time for gnu

to deprecate the ispell program in favour of aspell.  It would then be much easier for

emacs users to to consider ispell in emacs as the general framework for orthographic

correction.